
#include "allegro_emu.h"
#include <stdlib.h>
#include <stdio.h>

int _getpixel32(BITMAP *a, int x, int y) {
  return ((int *) a->line[y])[x];
}

void _putpixel32(BITMAP *a, int x, int y, int c) {
  ((int *) a->line[y])[x] = c;
}

int getr32(int c) {
  return c&255;
}

int getg32(int c) {
  return (c>>8)&255;
}

int getb32(int c) {
  return (c>>16)&255;
}

BITMAP *create_bitmap(int w, int h) {
  BITMAP *ans = new BITMAP();
  ans->w = w;
  ans->h = h;
  ans->data = new unsigned char[4*w*h];
  ans->line = new unsigned char*[h];
  for (int y = 0; y < h; y++) {
    ans->line[y] = &ans->data[y*4*w];
  }
  return ans;
}

void blit(BITMAP *a, BITMAP *b, int ax, int ay, int bx, int by, int w, int h) {
  if (ax != 0 || ay != 0 || bx != 0 || by != 0) { fprintf(stderr, "blit not fully implemented, nonzero coords not supported\n"); exit(1); }
  for (int y = 0; y < h; y++) {
    int *arow = (int *) a->line[y];
    int *brow = (int *) b->line[y];
    for (int x = 0; x < w; x++) {
      brow[x] = arow[x];
    }
  }
}

void destroy_bitmap(BITMAP *bmp) {
  if (!bmp) { return; }
  delete[] bmp->line;
  delete[] bmp->data;
  delete bmp;
}

fixed fixmul(fixed a0, fixed b0) {
  long long a = a0;
  long long b = b0;
  return (int) ((a*b)>>16);
}

void clear(BITMAP *bmp) {
  clear_to_color(bmp, 0);
}

void clear_to_color(BITMAP *bmp, int c) {
  for (int y = 0; y < bmp->h; y++) {
    int *row = (int *) bmp->line[y];
    for (int x = 0; x < bmp->w; x++) {
      row[x] = c;
    }
  }
}
