
/* PatchMatch with similarity transform of patches (rotation+scale). */

#ifndef _simnn_h
#define _simnn_h

#include "nn.h"

#define ANGLE_SHIFT XY_TO_INT_SHIFT
#define NUM_ANGLES (1<<ANGLE_SHIFT)
#define SCALE_SHIFT XY_TO_INT_SHIFT
#define NUM_SCALES (1<<SCALE_SHIFT)
#define SCALE_MIN 1.0
#define SCALE_MAX 1.0

class XFORM { public:
  int x0, y0, dxdu, dydu, dxdv, dydv;   /* Coords left shifted by 16. */
};

XFORM get_xform(Params *p, int x, int y, int scale, int theta);  /* x and y not left shifted. */

void getpixel_bilin(BITMAP *bimg, int bx, int by, int &r, int &g, int &b);  /* Coords left shifted by 16. */

BITMAP *sim_init_nn(Params *p, BITMAP *a, BITMAP *b, BITMAP *&ann_sim);
BITMAP *sim_init_dist(Params *p, BITMAP *a, BITMAP *b, BITMAP *ann, BITMAP *ann_sim);

void sim_nn(Params *p, BITMAP *a, BITMAP *b,
            BITMAP *ann, BITMAP *ann_sim, BITMAP *annd,
            RegionMasks *amask, BITMAP *bmask,
            int level, int em_iter, RecomposeParams *rp, int offset_iter, int update_type, int cache_b,
            RegionMasks *region_masks, int tiles);

BITMAP *sim_vote(Params *p, BITMAP *b,
                 BITMAP *ann, BITMAP *ann_sim, BITMAP *bnn=NULL, BITMAP *bnn_sim=NULL,
                 BITMAP *bmask=NULL, BITMAP *bweight=NULL,
                 double coherence_weight=COHERENCE_WEIGHT, double complete_weight=COMPLETE_WEIGHT,
                 RegionMasks *amask=NULL, BITMAP *aweight=NULL, BITMAP *ainit=NULL, RegionMasks *region_masks=NULL, BITMAP *aconstraint=NULL, int mask_self_only=0);

#endif
